#[doc = "Register `PID2` reader"]
pub struct R(crate::R<PID2_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<PID2_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<PID2_SPEC>> for R {
    fn from(reader: crate::R<PID2_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `PID2` writer"]
pub struct W(crate::W<PID2_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<PID2_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<PID2_SPEC>> for W {
    fn from(writer: crate::W<PID2_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `JEPID_MAJ` reader - JEP106 vendor id. 4 msbs of CPUSS.JEPID parameter. This number is maintained in spec 40-9500."]
pub struct JEPID_MAJ_R(crate::FieldReader<u8, u8>);
impl JEPID_MAJ_R {
    pub(crate) fn new(bits: u8) -> Self {
        JEPID_MAJ_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for JEPID_MAJ_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `REV` reader - Major REVision number (chip specific). Identifies the design iteration of the component. For first tape out: 0x1. This field is implemented in RTL by an ECO-able tie-off structure and is incremented on subsequent tape outs."]
pub struct REV_R(crate::FieldReader<u8, u8>);
impl REV_R {
    pub(crate) fn new(bits: u8) -> Self {
        REV_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for REV_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bits 0:2 - JEP106 vendor id. 4 msbs of CPUSS.JEPID parameter. This number is maintained in spec 40-9500."]
    #[inline(always)]
    pub fn jepid_maj(&self) -> JEPID_MAJ_R {
        JEPID_MAJ_R::new((self.bits & 0x07) as u8)
    }
    #[doc = "Bits 4:7 - Major REVision number (chip specific). Identifies the design iteration of the component. For first tape out: 0x1. This field is implemented in RTL by an ECO-able tie-off structure and is incremented on subsequent tape outs."]
    #[inline(always)]
    pub fn rev(&self) -> REV_R {
        REV_R::new(((self.bits >> 4) & 0x0f) as u8)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Peripheral Identification Register 2.\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pid2](index.html) module"]
pub struct PID2_SPEC;
impl crate::RegisterSpec for PID2_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [pid2::R](R) reader structure"]
impl crate::Readable for PID2_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [pid2::W](W) writer structure"]
impl crate::Writable for PID2_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets PID2 to value 0"]
impl crate::Resettable for PID2_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
